/* ----------------------------------------------------------------------------
 * File:       fc/fractal/FCFractal.java
 *
 * Author:     Unknown
 *
 * Copyright (c) - 1999, Technologies Interactives Mediagrif Inc.
 *
 * History
 * ----------------------------------------------------------------------------
 *  Date         User               Description
 * ----------------------------------------------------------------------------
 * 2000/02/11   Kris Fudalewski     Creation.
 * ----------------------------------------------------------------------------
 */
package fc.fractal;

import fc.accessible.*;

import java.util.Properties;
import java.util.Vector;

public abstract class FCFractal extends FCAccessible {

    public short  iterations;
    public double xOffset;
    public double yOffset;
    public double zoom;
    public double angle;
    public double fov;

    public FCFractal( Properties pProps ) {
        super( pProps );
    }

    public abstract short computePoint( double pX, double pY );

    public short computeViewPoint( int pX, int pY, int pSz ) {
        return computeViewPoint( pX, pY, pSz, pSz );
    }

    public short computeViewPoint( int pX, int pY, int pXVSz, int pYVSz ) {

        double wX = viewToSet( pX, pXVSz );
        double wY = viewToSet( pY, pYVSz );

/*        double d = (double)( pYVSz - pY );

        wX = ( wX * d ) / fov;
        wY = ( wY * fov ) / 1024; */

//        if ( pY == 0 ) {
//        	System.out.print( wX + " " );
//        } else if ( pY == 1 && pX == 0 ) {
//        	System.out.println();
//        }
        
        
        return computePoint( wX, wY );

    }

    public double getAngle() {
        return angle;
    }

    public void setAngle( double pAngle ) {
        angle = pAngle;
    }

    public short getIterations() {
        return iterations;
    }

    public void setIterations( short pIterations ) {
        iterations = pIterations;
    }

    public double getZoom() {
        return zoom;
    }

    public void setZoom( double pZoom ) {
        zoom = pZoom;
    }

    public double getXOffset() {
        return xOffset;
    }

    public void setXOffset( double pXOffset ) {
        xOffset = pXOffset;
    }

    public double getYOffset() {
        return yOffset;
    }

    public void setYOffset( double pYOffset ) {
        yOffset = pYOffset;
    }

    public double getFov() {
        return fov;
    }

    public void setFov( double pFov ) {
        fov = pFov;
    }

    public int getType() {
    	return FCAccessibleContainer.ACCESSIBLE_FRACTAL;
    }
    
    public double viewToSet( double pValue, int pSize ) {
        return (double)( pValue - ( pSize >> 1 ) ) / zoom;
    }

}
