/* ----------------------------------------------------------------------------
 * File:       fc/fractal/FCJuliaFractal.java
 *
 * Author:     Unknown
 *
 * Copyright (c) - 1999, Technologies Interactives Mediagrif Inc.
 *
 * History
 * ----------------------------------------------------------------------------
 *  Date         User               Description
 * ----------------------------------------------------------------------------
 * 2000/02/11   Kris Fudalewski     Creation.
 * ----------------------------------------------------------------------------
 */
package fc.fractal;

import java.math.BigDecimal;
import java.math.MathContext;
import java.util.Properties;

public class FCJuliaFractal extends FCFractal {

	private double cReal;
    private double cImag;
    private double multiplier;
    private double velocityLimit;

    public FCJuliaFractal( Properties pProps ) {
        super( pProps );
    }

    public short computePoint( double pX, double pY ) {

        short wIter = 0;

        double wImagSq = 0;
        double wRealSq = 0;

//        double wX = xOffset + pX - 0.5;
//        double wY = yOffset + pY;
        
//      BigDecimal wBX = new BigDecimal( xOffset, MathContext.DECIMAL128 ).add( new BigDecimal( pX, MathContext.DECIMAL128  ) ).subtract( new BigDecimal( 0.5, MathContext.DECIMAL128  ) );
//        System.out.println( pX + " + " + xOffset + " = " + wX + " (" + wBX + " [" + wBX.precision() + "] )" );
        
        double wImag = pX + xOffset;
        double wReal = pY + yOffset;
        double wMImag = cImag;
        double wMReal = cReal;

        // -- Mandelbrot set iteration.
        do {

            wRealSq = ( wReal * wReal );
            wImagSq = ( wImag * wImag );
            wReal = ( multiplier * wImag * wReal ) + wMReal;
            wImag = ( wImagSq - wRealSq ) + wMImag;

            wIter++;

        } while ( ( wImagSq + wRealSq < velocityLimit ) && wIter < iterations );

        return wIter;

    }

    public double getConstReal() {
        return cReal;
    }

    public void setConstReal( double pConstReal ) {
        cReal = pConstReal;
    }

    public double getConstImag() {
        return cImag;
    }

    public double getMultiplier() {
    	return multiplier;
    }
    
    public double getVelocityLimit() {
    	return velocityLimit;
    }
    
    public void setConstImag( double pConstImag ) {
        cImag = pConstImag;
    }

    public void setMultiplier( double pMultiplier ) {
    	multiplier = pMultiplier;
    }
    
    public void setVelocityLimit( double pVelocityLimit ) {
    	velocityLimit = pVelocityLimit;
    }
    
    
}

