package fc.renderer;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.util.Properties;

public class FCDefaultRenderer extends FCRenderer {

    public FCDefaultRenderer( Properties pProp ) {
        super( pProp );
    }

    public void paint( Graphics pGrp ) {

        super.paint( pGrp );

        // -- Get clipping bounds
        Rectangle wBounds = pGrp.getClipBounds();

        int wDetailLevel = getDetailLevel();
        Dimension wVSz  = getViewportSize();

        // -- Adjust the detail level if we don't have enought place to render at the specified detail level.
        int wMdl = Math.min( wBounds.width, wBounds.height );
        
        if ( wMdl > 0 && wDetailLevel > wMdl ) {
        	wDetailLevel = wMdl;
        }
        
        stop = false;
        
        // -- Render details
        for ( int y = wBounds.y; y < wBounds.y + wBounds.height; y += wDetailLevel ) {

            for( int x = wBounds.x; x < wBounds.x + wBounds.width; x += wDetailLevel ) {

                drawPoint( 
                	pGrp, 
                	x, 
                	y, 
                	getFractal().computeViewPoint( x, y, wVSz.width, wVSz.height ) );

            }

            if ( stop ) {
            	break;
            } else {
            	Thread.yield();
            }
            
        }

//        System.out.print( wBx + " " + wBy + "\r\n" );
        
        
        
    }

}